diff -Naur tomato/release/src/router/pppd/pppd/sys-linux.c tomato121/release/src/router/pppd/pppd/sys-linux.c
--- tomato/release/src/router/pppd/pppd/sys-linux.c	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/sys-linux.c	2008-04-22 21:44:05.000000000 +1000
@@ -2,20 +2,71 @@
  * sys-linux.c - System-dependent procedures for setting up
  * PPP interfaces on Linux systems
  *
- * Copyright (c) 1989 Carnegie Mellon University.
- * All rights reserved.
+ * Copyright (c) 1994-2004 Paul Mackerras. All rights reserved.
  *
- * Redistribution and use in source and binary forms are permitted
- * provided that the above copyright notice and this paragraph are
- * duplicated in all such forms and that any documentation,
- * advertising materials, and other materials related to such
- * distribution and use acknowledge that the software was developed
- * by Carnegie Mellon University.  The name of the
- * University may not be used to endorse or promote products derived
- * from this software without specific prior written permission.
- * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
- * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. The name(s) of the authors of this software must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission.
+ *
+ * 3. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Paul Mackerras
+ *     <paulus@samba.org>".
+ *
+ * THE AUTHORS OF THIS SOFTWARE DISCLAIM ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY
+ * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Derived from main.c and pppd.h, which are:
+ *
+ * Copyright (c) 1984-2000 Carnegie Mellon University. All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name "Carnegie Mellon University" must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission. For permission or any legal
+ *    details, please contact
+ *      Office of Technology Transfer
+ *      Carnegie Mellon University
+ *      5000 Forbes Avenue
+ *      Pittsburgh, PA  15213-3890
+ *      (412) 268-4387, fax: (412) 268-7395
+ *      tech-transfer@andrew.cmu.edu
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Computing Services
+ *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
+ *
+ * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
+ * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  */
 
 #include <sys/ioctl.h>
@@ -85,7 +136,7 @@
 #endif /* IPX_CHANGE */
 
 #ifdef PPP_FILTER
-#include <net/bpf.h>
+#include <pcap-bpf.h>
 #include <linux/filter.h>
 #endif /* PPP_FILTER */
 
@@ -108,7 +159,7 @@
 
 #define IN6_LLADDR_FROM_EUI64(sin6, eui64) do {			\
 	memset(&sin6.s6_addr, 0, sizeof(struct in6_addr));	\
-	sin6.s6_addr16[0] = htons(0xfe80); 			\
+	sin6.s6_addr16[0] = htons(0xfe80);			\
 	eui64_copy(eui64, sin6.s6_addr32[2]);			\
 	} while (0)
 
@@ -122,12 +173,19 @@
 static int initfdflags = -1;	/* Initial file descriptor flags for fd */
 static int ppp_fd = -1;		/* fd which is set to PPP discipline */
 static int sock_fd = -1;	/* socket for doing interface ioctls */
-static int slave_fd = -1;
-static int master_fd = -1;
+static int slave_fd = -1;	/* pty for old-style demand mode, slave */
+static int master_fd = -1;	/* pty for old-style demand mode, master */
 #ifdef INET6
 static int sock6_fd = -1;
 #endif /* INET6 */
-static int ppp_dev_fd = -1;	/* fd for /dev/ppp (new style driver) */
+
+/*
+ * For the old-style kernel driver, this is the same as ppp_fd.
+ * For the new-style driver, it is the fd of an instance of /dev/ppp
+ * which is attached to the ppp unit and is used for controlling it.
+ */
+int ppp_dev_fd = -1;		/* fd for /dev/ppp (new style driver) */
+
 static int chindex;		/* channel index (new style driver) */
 
 static fd_set in_fds;		/* set of fds that wait_input waits for */
@@ -141,13 +199,13 @@
 static int restore_term        = 0;	/* 1 => we've munged the terminal */
 static struct termios inittermios;	/* Initial TTY termios */
 
-static int new_style_driver = 0;
+int new_style_driver = 0;
 
 static char loop_name[20];
 static unsigned char inbuf[512]; /* buffer for chars read from loopback */
 
 static int	if_is_up;	/* Interface has been marked up */
-static u_int32_t default_route_gateway;	/* Gateway for default route added */
+static int	have_default_route;	/* Gateway for default route added */
 static u_int32_t proxy_arp_addr;	/* Addr for proxy arp entry added */
 static char proxy_arp_dev[16];		/* Device for proxy arp entry */
 static u_int32_t our_old_addr;		/* for detecting address changes */
@@ -168,8 +226,7 @@
 #define SIN_ADDR(x)	(((struct sockaddr_in *) (&(x)))->sin_addr.s_addr)
 
 /* Prototypes for procedures local to this file. */
-static int get_flags (int fd);
-static void set_flags (int fd, int flags);
+static int modify_flags(int fd, int clear_bits, int set_bits);
 static int translate_speed (int bps);
 static int baud_rate_of (int speed);
 static void close_route_table (void);
@@ -182,7 +239,6 @@
 static int set_kdebugflag(int level);
 static int ppp_registered(void);
 static int make_ppp_unit(void);
-static void restore_loop(void);	/* Transfer ppp unit back to loopback */
 
 extern u_char	inpacket_buf[];	/* borrowed from main.c */
 
@@ -204,7 +260,6 @@
 /* new_fd is the fd of a tty */
 static void set_ppp_fd (int new_fd)
 {
-	SYSDEBUG ((LOG_DEBUG, "setting ppp_fd to %d\n", new_fd));
 	ppp_fd = new_fd;
 	if (!new_style_driver)
 		ppp_dev_fd = new_fd;
@@ -223,36 +278,26 @@
 	return 0;
 }
 
-/********************************************************************
- *
- * Functions to read and set the flags value in the device driver
+/*
+ * modify_flags - set and clear flag bits controlling the kernel
+ * PPP driver.
  */
+static int modify_flags(int fd, int clear_bits, int set_bits)
+{
+	int flags;
 
-static int get_flags (int fd)
-{    
-    int flags;
-
-    if (ioctl(fd, PPPIOCGFLAGS, (caddr_t) &flags) < 0) {
-	if ( ok_error (errno) )
-	    flags = 0;
-	else
-	    fatal("ioctl(PPPIOCGFLAGS): %m");
-    }
-
-    SYSDEBUG ((LOG_DEBUG, "get flags = %x\n", flags));
-    return flags;
-}
-
-/********************************************************************/
+	if (ioctl(fd, PPPIOCGFLAGS, &flags) == -1)
+		goto err;
+	flags = (flags & ~clear_bits) | set_bits;
+	if (ioctl(fd, PPPIOCSFLAGS, &flags) == -1)
+		goto err;
 
-static void set_flags (int fd, int flags)
-{    
-    SYSDEBUG ((LOG_DEBUG, "set flags = %x\n", flags));
+	return 0;
 
-    if (ioctl(fd, PPPIOCSFLAGS, (caddr_t) &flags) < 0) {
-	if (! ok_error (errno) )
-	    fatal("ioctl(PPPIOCSFLAGS, %x): %m", flags, errno);
-    }
+ err:
+	if (errno != EIO)
+		error("Failed to set PPP kernel option flags: %m");
+	return -1;
 }
 
 /********************************************************************
@@ -262,18 +307,6 @@
 
 void sys_init(void)
 {
-    int flags;
-
-    if (new_style_driver) {
-	ppp_dev_fd = open("/dev/ppp", O_RDWR);
-	if (ppp_dev_fd < 0)
-	    fatal("Couldn't open /dev/ppp: %m");
-	flags = fcntl(ppp_dev_fd, F_GETFL);
-	if (flags == -1
-	    || fcntl(ppp_dev_fd, F_SETFL, flags | O_NONBLOCK) == -1)
-	    warn("Couldn't set /dev/ppp to nonblock: %m");
-    }
-
     /* Get an internet socket for doing socket ioctls. */
     sock_fd = socket(AF_INET, SOCK_DGRAM, 0);
     if (sock_fd < 0)
@@ -308,8 +341,8 @@
 /*
  * Delete any routes through the device.
  */
-    if (default_route_gateway != 0)
-	cifdefaultroute(0, 0, default_route_gateway);
+    if (have_default_route)
+	cifdefaultroute(0, 0, 0);
 
     if (has_proxy_arp)
 	cifproxyarp(0, proxy_arp_addr);
@@ -322,15 +355,18 @@
 void
 sys_close(void)
 {
-    if (new_style_driver)
+    if (new_style_driver && ppp_dev_fd >= 0)
 	close(ppp_dev_fd);
     if (sock_fd >= 0)
 	close(sock_fd);
+#ifdef INET6
+    if (sock6_fd >= 0)
+	close(sock6_fd);
+#endif
     if (slave_fd >= 0)
 	close(slave_fd);
     if (master_fd >= 0)
 	close(master_fd);
-    closelog();
 }
 
 /********************************************************************
@@ -340,15 +376,13 @@
 
 static int set_kdebugflag (int requested_level)
 {
-    if (new_style_driver && ifunit < 0)
+    if (ppp_dev_fd < 0)
 	return 1;
     if (ioctl(ppp_dev_fd, PPPIOCSDEBUG, &requested_level) < 0) {
 	if ( ! ok_error (errno) )
-	    error("ioctl(PPPIOCSDEBUG): %m");
+	    error("ioctl(PPPIOCSDEBUG): %m (line %d)", __LINE__);
 	return (0);
     }
-    SYSDEBUG ((LOG_INFO, "set kernel debugging level to %d",
-		requested_level));
     return (1);
 }
 
@@ -359,22 +393,23 @@
 
 int tty_establish_ppp (int tty_fd)
 {
-    int x;
-    int fd = -1;
+    int ret_fd;
 
 /*
  * Ensure that the tty device is in exclusive mode.
  */
     if (ioctl(tty_fd, TIOCEXCL, 0) < 0) {
 	if ( ! ok_error ( errno ))
+	{
 	    warn("Couldn't make tty exclusive: %m");
+	}
     }
 /*
  * Demand mode - prime the old ppp device to relinquish the unit.
  */
     if (!new_style_driver && looped
 	&& ioctl(slave_fd, PPPIOCXFERUNIT, 0) < 0) {
-	error("ioctl(transfer ppp unit): %m");
+	error("ioctl(transfer ppp unit): %m, line %d", __LINE__);
 	return -1;
     }
 /*
@@ -392,11 +427,38 @@
 	}
     }
 
+    ret_fd = generic_establish_ppp(tty_fd);
+
+#define SC_RCVB	(SC_RCV_B7_0 | SC_RCV_B7_1 | SC_RCV_EVNP | SC_RCV_ODDP)
+#define SC_LOGB	(SC_DEBUG | SC_LOG_INPKT | SC_LOG_OUTPKT | SC_LOG_RAWIN \
+		 | SC_LOG_FLUSH)
+
+    if (ret_fd >= 0) {
+	modify_flags(ppp_fd, SC_RCVB | SC_LOGB,
+		     (kdebugflag * SC_DEBUG) & SC_LOGB);
+    } else {
+	if (ioctl(tty_fd, TIOCSETD, &tty_disc) < 0 && !ok_error(errno))
+	{
+	    warn("Couldn't reset tty to normal line discipline: %m");
+	}
+    }
+
+    return ret_fd;
+}
+
+/********************************************************************
+ *
+ * generic_establish_ppp - Turn the fd into a ppp interface.
+ */
+int generic_establish_ppp (int fd)
+{
+    int x;
+
     if (new_style_driver) {
-	/* Open another instance of /dev/ppp and connect the channel to it */
 	int flags;
 
-	if (ioctl(tty_fd, PPPIOCGCHAN, &chindex) == -1) {
+	/* Open an instance of /dev/ppp and connect the channel to it */
+	if (ioctl(fd, PPPIOCGCHAN, &chindex) == -1) {
 	    error("Couldn't get channel number: %m");
 	    goto err;
 	}
@@ -406,6 +468,7 @@
 	    error("Couldn't reopen /dev/ppp: %m");
 	    goto err;
 	}
+	(void) fcntl(fd, F_SETFD, FD_CLOEXEC);
 	if (ioctl(fd, PPPIOCATTCHAN, &chindex) < 0) {
 	    error("Couldn't attach to channel %d: %m", chindex);
 	    goto err_close;
@@ -426,7 +489,7 @@
 	}
 
 	if (looped)
-	    set_flags(ppp_dev_fd, get_flags(ppp_dev_fd) & ~SC_LOOP_TRAFFIC);
+	    modify_flags(ppp_dev_fd, SC_LOOP_TRAFFIC, 0);
 
 	if (!multilink) {
 	    add_fd(ppp_dev_fd);
@@ -440,11 +503,11 @@
 	/*
 	 * Old-style driver: find out which interface we were given.
 	 */
-	set_ppp_fd (tty_fd);
-	if (ioctl(tty_fd, PPPIOCGUNIT, &x) < 0) {	
+	set_ppp_fd (fd);
+	if (ioctl(fd, PPPIOCGUNIT, &x) < 0) {
 	    if (ok_error (errno))
 		goto err;
-	    fatal("ioctl(PPPIOCGUNIT): %m(%d)", errno);
+	    fatal("ioctl(PPPIOCGUNIT): %m (line %d)", __LINE__);
 	}
 	/* Check that we got the same unit again. */
 	if (looped && x != ifunit)
@@ -454,87 +517,105 @@
 	/*
 	 * Fetch the initial file flags and reset blocking mode on the file.
 	 */
-	initfdflags = fcntl(tty_fd, F_GETFL);
+	initfdflags = fcntl(fd, F_GETFL);
 	if (initfdflags == -1 ||
-	    fcntl(tty_fd, F_SETFL, initfdflags | O_NONBLOCK) == -1) {
+	    fcntl(fd, F_SETFL, initfdflags | O_NONBLOCK) == -1) {
 	    if ( ! ok_error (errno))
+	    {
 		warn("Couldn't set device to non-blocking mode: %m");
+	    }
 	}
     }
 
-    looped = 0;
-
     /*
      * Enable debug in the driver if requested.
      */
     if (!looped)
 	set_kdebugflag (kdebugflag);
 
-#define SC_RCVB	(SC_RCV_B7_0 | SC_RCV_B7_1 | SC_RCV_EVNP | SC_RCV_ODDP)
-#define SC_LOGB	(SC_DEBUG | SC_LOG_INPKT | SC_LOG_OUTPKT | SC_LOG_RAWIN \
-		 | SC_LOG_FLUSH)
-
-    set_flags(ppp_fd, ((get_flags(ppp_fd) & ~(SC_RCVB | SC_LOGB))
-		       | ((kdebugflag * SC_DEBUG) & SC_LOGB)));
-
-    SYSDEBUG ((LOG_NOTICE, "Using version %d.%d.%d of PPP driver",
-	    driver_version, driver_modification, driver_patch));
+    looped = 0;
 
     return ppp_fd;
 
  err_close:
     close(fd);
  err:
-    if (ioctl(tty_fd, TIOCSETD, &tty_disc) < 0 && !ok_error(errno))
-	warn("Couldn't reset tty to normal line discipline: %m");
     return -1;
 }
 
 /********************************************************************
  *
- * tty_disestablish_ppp - Restore the serial port to normal operation,
- * and reconnect the ppp unit to the loopback if in demand mode.
+ * tty_disestablish_ppp - Restore the serial port to normal operation.
  * This shouldn't call die() because it's called from die().
  */
 
 void tty_disestablish_ppp(int tty_fd)
 {
-    if (demand)
-	restore_loop();
     if (!hungup) {
 /*
  * Flush the tty output buffer so that the TIOCSETD doesn't hang.
  */
 	if (tcflush(tty_fd, TCIOFLUSH) < 0)
+	{
 	    warn("tcflush failed: %m");
+	    goto flushfailed;
+	}
 /*
  * Restore the previous line discipline
  */
 	if (ioctl(tty_fd, TIOCSETD, &tty_disc) < 0) {
 	    if ( ! ok_error (errno))
-		error("ioctl(TIOCSETD, N_TTY): %m");
+	    {
+		error("ioctl(TIOCSETD, N_TTY): %m (line %d)", __LINE__);
+	    }
 	}
-	
+
 	if (ioctl(tty_fd, TIOCNXCL, 0) < 0) {
 	    if ( ! ok_error (errno))
-		warn("ioctl(TIOCNXCL): %m(%d)", errno);
+	    {
+		warn("ioctl(TIOCNXCL): %m (line %d)", __LINE__);
+	    }
 	}
 
 	/* Reset non-blocking mode on fd. */
 	if (initfdflags != -1 && fcntl(tty_fd, F_SETFL, initfdflags) < 0) {
 	    if ( ! ok_error (errno))
+	    {
 		warn("Couldn't restore device fd flags: %m");
+	    }
 	}
     }
+flushfailed:
     initfdflags = -1;
 
+    generic_disestablish_ppp(tty_fd);
+}
+
+/********************************************************************
+ *
+ * generic_disestablish_ppp - Restore device components to normal
+ * operation, and reconnect the ppp unit to the loopback if in demand
+ * mode.  This shouldn't call die() because it's called from die().
+ */
+void generic_disestablish_ppp(int dev_fd)
+{
     if (new_style_driver) {
 	close(ppp_fd);
 	ppp_fd = -1;
-	if (!looped && ifunit >= 0 && ioctl(ppp_dev_fd, PPPIOCDETACH) < 0)
-	    error("Couldn't release PPP unit: %m");
-	if (!multilink)
+	if (demand) {
+	    modify_flags(ppp_dev_fd, 0, SC_LOOP_TRAFFIC);
+	    looped = 1;
+	} else if (!doing_multilink && ppp_dev_fd >= 0) {
+	    close(ppp_dev_fd);
 	    remove_fd(ppp_dev_fd);
+	    ppp_dev_fd = -1;
+	}
+    } else {
+	/* old-style driver */
+	if (demand)
+	    set_ppp_fd(slave_fd);
+	else
+	    ppp_dev_fd = -1;
     }
 }
 
@@ -544,17 +625,35 @@
  */
 static int make_ppp_unit()
 {
-	int x;
+	int x, flags;
+
+	if (ppp_dev_fd >= 0) {
+		dbglog("in make_ppp_unit, already had /dev/ppp open?");
+		close(ppp_dev_fd);
+	}
+	ppp_dev_fd = open("/dev/ppp", O_RDWR);
+	if (ppp_dev_fd < 0)
+	 {
+		fatal("Couldn't open /dev/ppp: %m");
+	 }
+	flags = fcntl(ppp_dev_fd, F_GETFL);
+	if (flags == -1
+	    || fcntl(ppp_dev_fd, F_SETFL, flags | O_NONBLOCK) == -1)
+	    {
+		warn("Couldn't set /dev/ppp to nonblock: %m");
+	    }
 
 	ifunit = req_unit;
 	x = ioctl(ppp_dev_fd, PPPIOCNEWUNIT, &ifunit);
 	if (x < 0 && req_unit >= 0 && errno == EEXIST) {
-		warn("Couldn't allocate PPP unit %d as it is already in use");
+		warn("Couldn't allocate PPP unit %d as it is already in use", req_unit);
 		ifunit = -1;
 		x = ioctl(ppp_dev_fd, PPPIOCNEWUNIT, &ifunit);
 	}
 	if (x < 0)
+	{
 		error("Couldn't create new ppp unit: %m");
+	}
 	return x;
 }
 
@@ -564,20 +663,16 @@
  */
 void cfg_bundle(int mrru, int mtru, int rssn, int tssn)
 {
-	int flags;
-
 	if (!new_style_driver)
 		return;
 
 	/* set the mrru, mtu and flags */
 	if (ioctl(ppp_dev_fd, PPPIOCSMRRU, &mrru) < 0)
 		error("Couldn't set MRRU: %m");
-	flags = get_flags(ppp_dev_fd);
-	flags &= ~(SC_MP_SHORTSEQ | SC_MP_XSHORTSEQ);
-	flags |= (rssn? SC_MP_SHORTSEQ: 0) | (tssn? SC_MP_XSHORTSEQ: 0)
-		| (mrru? SC_MULTILINK: 0);
 
-	set_flags(ppp_dev_fd, flags);
+	modify_flags(ppp_dev_fd, SC_MP_SHORTSEQ|SC_MP_XSHORTSEQ|SC_MULTILINK,
+		     ((rssn? SC_MP_SHORTSEQ: 0) | (tssn? SC_MP_XSHORTSEQ: 0)
+		      | (mrru? SC_MULTILINK: 0)));
 
 	/* connect up the channel */
 	if (ioctl(ppp_fd, PPPIOCCONNECT, &ifunit) < 0)
@@ -611,22 +706,42 @@
  */
 int bundle_attach(int ifnum)
 {
+	int master_fd;
+
 	if (!new_style_driver)
 		return -1;
 
-	if (ioctl(ppp_dev_fd, PPPIOCATTACH, &ifnum) < 0) {
-		if (errno == ENXIO)
+	master_fd = open("/dev/ppp", O_RDWR);
+	if (master_fd < 0)
+		fatal("Couldn't open /dev/ppp: %m");
+	if (ioctl(master_fd, PPPIOCATTACH, &ifnum) < 0) {
+		if (errno == ENXIO) {
+			close(master_fd);
 			return 0;	/* doesn't still exist */
+		}
 		fatal("Couldn't attach to interface unit %d: %m\n", ifnum);
 	}
 	if (ioctl(ppp_fd, PPPIOCCONNECT, &ifnum) < 0)
 		fatal("Couldn't connect to interface unit %d: %m", ifnum);
-	set_flags(ppp_dev_fd, get_flags(ppp_dev_fd) | SC_MULTILINK);
+	modify_flags(master_fd, 0, SC_MULTILINK);
+	close(master_fd);
 
 	ifunit = ifnum;
 	return 1;
 }
 
+/*
+ * destroy_bundle - tell the driver to destroy our bundle.
+ */
+void destroy_bundle(void)
+{
+	if (ppp_dev_fd >= 0) {
+		close(ppp_dev_fd);
+		remove_fd(ppp_dev_fd);
+		ppp_dev_fd = -1;
+	}
+}
+
 /********************************************************************
  *
  * clean_check - Fetch the flags for the device and generate
@@ -644,20 +759,20 @@
 	    case SC_RCV_B7_0:
 		s = "all had bit 7 set to 1";
 		break;
-		
+
 	    case SC_RCV_B7_1:
 		s = "all had bit 7 set to 0";
 		break;
-		
+
 	    case SC_RCV_EVNP:
 		s = "all had odd parity";
 		break;
-		
+
 	    case SC_RCV_ODDP:
 		s = "all had even parity";
 		break;
 	    }
-	    
+
 	    if (s != NULL) {
 		warn("Receive serial link is not 8-bit clean:");
 		warn("Problem: %s", s);
@@ -665,7 +780,7 @@
 	}
     }
 }
-	
+
 
 /*
  * List of valid speeds.
@@ -782,7 +897,7 @@
 static int baud_rate_of (int speed)
 {
     struct speed *speedp;
-    
+
     if (speed != 0) {
 	for (speedp = speeds; speedp->speed_int; speedp++) {
 	    if (speed == speedp->speed_val)
@@ -807,13 +922,13 @@
     setdtr(tty_fd, 1);
     if (tcgetattr(tty_fd, &tios) < 0) {
 	if (!ok_error(errno))
-	    fatal("tcgetattr: %m(%d)", errno);
+	    fatal("tcgetattr: %m (line %d)", __LINE__);
 	return;
     }
-    
+
     if (!restore_term)
 	inittermios = tios;
-    
+
     tios.c_cflag     &= ~(CSIZE | CSTOPB | PARENB | CLOCAL);
     tios.c_cflag     |= CS8 | CREAD | HUPCL;
 
@@ -822,7 +937,7 @@
     tios.c_lflag      = 0;
     tios.c_cc[VMIN]   = 1;
     tios.c_cc[VTIME]  = 0;
-    
+
     if (local || !modem)
 	tios.c_cflag ^= (CLOCAL | HUPCL);
 
@@ -844,7 +959,7 @@
     default:
 	break;
     }
-    
+
     speed = translate_speed(inspeed);
     if (speed) {
 	cfsetospeed (&tios, speed);
@@ -860,10 +975,10 @@
 	    fatal("Baud rate for %s is 0; need explicit baud rate", devnam);
     }
 
-    if (tcsetattr(tty_fd, TCSAFLUSH, &tios) < 0)
-	if (!ok_error(errno))
-	    fatal("tcsetattr: %m");
-    
+    while (tcsetattr(tty_fd, TCSAFLUSH, &tios) < 0 && !ok_error(errno))
+	if (errno != EINTR)
+	    fatal("tcsetattr: %m (line %d)", __LINE__);
+
     baud_rate    = baud_rate_of(speed);
     restore_term = 1;
 }
@@ -898,10 +1013,12 @@
  */
 	if (!default_device)
 	    inittermios.c_lflag &= ~(ECHO | ECHONL);
-	
+
 	if (tcsetattr(tty_fd, TCSAFLUSH, &inittermios) < 0) {
 	    if (! ok_error (errno))
-		warn("tcsetattr: %m");
+	    {
+		warn("tcsetattr: %m (line %d)", __LINE__);
+	    }
 	}
     }
 }
@@ -916,8 +1033,8 @@
     int fd = ppp_fd;
     int proto;
 
-    if (debug)
-	dbglog("sent %P", p, len);
+    dump_packet("sent", p, len);
+    if (snoop_send_hook) snoop_send_hook(p, len);
 
     if (len < PPP_HDRLEN)
 	return;
@@ -925,15 +1042,18 @@
 	p += 2;
 	len -= 2;
 	proto = (p[0] << 8) + p[1];
-	if (ifunit >= 0 && !(proto >= 0xc000 || proto == PPP_CCPFRAG))
+	if (ppp_dev_fd >= 0 && !(proto >= 0xc000 || proto == PPP_CCPFRAG))
 	    fd = ppp_dev_fd;
     }
     if (write(fd, p, len) < 0) {
-	if (errno == EWOULDBLOCK || errno == ENOBUFS
+	if (errno == EWOULDBLOCK || errno == EAGAIN || errno == ENOBUFS
 	    || errno == ENXIO || errno == EIO || errno == EINTR)
+	    {
 	    warn("write: warning: %m (%d)", errno);
-	else
+	    }
+	else{
 	    error("write: %m (%d)", errno);
+	    }
     }
 }
 
@@ -953,7 +1073,7 @@
     exc = in_fds;
     n = select(max_in_fd + 1, &ready, NULL, &exc, timo);
     if (n < 0 && errno != EINTR)
-	fatal("select: %m(%d)", errno);
+	fatal("select: %m");
 }
 
 /*
@@ -961,6 +1081,8 @@
  */
 void add_fd(int fd)
 {
+    if (fd >= FD_SETSIZE)
+	fatal("internal error: file descriptor too large (%d)", fd);
     FD_SET(fd, &in_fds);
     if (fd > max_in_fd)
 	max_in_fd = fd;
@@ -993,19 +1115,27 @@
     nr = -1;
     if (ppp_fd >= 0) {
 	nr = read(ppp_fd, buf, len);
-	if (nr < 0 && errno != EWOULDBLOCK && errno != EIO && errno != EINTR)
+	if (nr < 0 && errno != EWOULDBLOCK && errno != EAGAIN
+	    && errno != EIO && errno != EINTR)
 	    error("read: %m");
 	if (nr < 0 && errno == ENXIO)
 	    return 0;
     }
-    if (nr < 0 && new_style_driver && ifunit >= 0) {
+    if (nr < 0 && new_style_driver && ppp_dev_fd >= 0 && !bundle_eof) {
 	/* N.B. we read ppp_fd first since LCP packets come in there. */
 	nr = read(ppp_dev_fd, buf, len);
-	if (nr < 0 && errno != EWOULDBLOCK && errno != EIO && errno != EINTR)
+	if (nr < 0 && errno != EWOULDBLOCK && errno != EAGAIN
+	    && errno != EIO && errno != EINTR)
 	    error("read /dev/ppp: %m");
 	if (nr < 0 && errno == ENXIO)
-	    return 0;
+	    nr = 0;
+	if (nr == 0 && doing_multilink) {
+	    remove_fd(ppp_dev_fd);
+	    bundle_eof = 1;
+	}
     }
+    if (new_style_driver && ppp_fd < 0 && ppp_dev_fd < 0)
+	nr = 0;
     return (new_style_driver && nr > 0)? nr+2: nr;
 }
 
@@ -1035,7 +1165,7 @@
     if (n == 0)
 	fatal("eof on loopback");
 
-    if (errno != EWOULDBLOCK)
+    if (errno != EWOULDBLOCK && errno != EAGAIN)
 	fatal("read from loopback: %m(%d)", errno);
 
     return rv;
@@ -1049,14 +1179,30 @@
 {
     struct ifreq ifr;
 
-    SYSDEBUG ((LOG_DEBUG, "netif_set_mtu: mtu = %d\n", mtu));
-
     memset (&ifr, '\0', sizeof (ifr));
     strlcpy(ifr.ifr_name, ifname, sizeof (ifr.ifr_name));
     ifr.ifr_mtu = mtu;
-	
+//    info("set mtu ppp to %s (%d)\n",ifname,mtu);
     if (ifunit >= 0 && ioctl(sock_fd, SIOCSIFMTU, (caddr_t) &ifr) < 0)
-	fatal("ioctl(SIOCSIFMTU): %m");
+	error("ioctl(SIOCSIFMTU): %m (line %d)", __LINE__);
+}
+
+/*
+ * netif_get_mtu - get the MTU on the PPP network interface.
+ */
+int
+netif_get_mtu(int unit)
+{
+    struct ifreq ifr;
+
+    memset (&ifr, '\0', sizeof (ifr));
+    strlcpy(ifr.ifr_name, ifname, sizeof (ifr.ifr_name));
+
+    if (ifunit >= 0 && ioctl(sock_fd, SIOCGIFMTU, (caddr_t) &ifr) < 0) {
+	error("ioctl(SIOCGIFMTU): %m (line %d)", __LINE__);
+	return 0;
+    }
+    return ifr.ifr_mtu;
 }
 
 /********************************************************************
@@ -1065,28 +1211,25 @@
  * the ppp interface.
  */
 
-void tty_send_config (int mtu,u_int32_t asyncmap,int pcomp,int accomp)
+void tty_send_config(int mtu, u_int32_t asyncmap, int pcomp, int accomp)
 {
-    u_int x;
+	int x;
 
-/*
- * Set the asyncmap and other parameters for the ppp device
- */
-    if (!still_ppp())
-	return;
-    link_mtu = mtu;
-    SYSDEBUG ((LOG_DEBUG, "send_config: asyncmap = %lx\n", asyncmap));
-    if (ioctl(ppp_fd, PPPIOCSASYNCMAP, (caddr_t) &asyncmap) < 0) {
-	if (!ok_error(errno))
-	    fatal("ioctl(PPPIOCSASYNCMAP): %m(%d)", errno);
-	return;
-    }
-    
-    x = get_flags(ppp_fd);
-    x = pcomp  ? x | SC_COMP_PROT : x & ~SC_COMP_PROT;
-    x = accomp ? x | SC_COMP_AC   : x & ~SC_COMP_AC;
-    x = sync_serial ? x | SC_SYNC : x & ~SC_SYNC;
-    set_flags(ppp_fd, x);
+	if (!still_ppp())
+		return;
+	link_mtu = mtu;
+	if (ioctl(ppp_fd, PPPIOCSASYNCMAP, (caddr_t) &asyncmap) < 0) {
+		if (errno != EIO && errno != ENOTTY)
+		{
+			error("Couldn't set transmit async character map: %m");
+		}
+		++error_count;
+		return;
+	}
+
+	x = (pcomp? SC_COMP_PROT: 0) | (accomp? SC_COMP_AC: 0)
+	    | (sync_serial? SC_SYNC: 0);
+	modify_flags(ppp_fd, SC_COMP_PROT|SC_COMP_AC|SC_SYNC, x);
 }
 
 /********************************************************************
@@ -1096,14 +1239,11 @@
 
 void tty_set_xaccm (ext_accm accm)
 {
-    SYSDEBUG ((LOG_DEBUG, "set_xaccm: %08lx %08lx %08lx %08lx\n",
-		accm[0], accm[1], accm[2], accm[3]));
-
     if (!still_ppp())
 	return;
     if (ioctl(ppp_fd, PPPIOCSXASYNCMAP, accm) < 0 && errno != ENOTTY) {
 	if ( ! ok_error (errno))
-	    warn("ioctl(set extended ACCM): %m(%d)", errno);
+	    warn("ioctl(set extended ACCM): %m (line %d)", __LINE__);
     }
 }
 
@@ -1113,31 +1253,29 @@
  * the ppp interface.
  */
 
-void tty_recv_config (int mru,u_int32_t asyncmap,int pcomp,int accomp)
+void tty_recv_config(int mru, u_int32_t asyncmap, int pcomp, int accomp)
 {
-    SYSDEBUG ((LOG_DEBUG, "recv_config: mru = %d\n", mru));
 /*
  * If we were called because the link has gone down then there is nothing
  * which may be done. Just return without incident.
  */
-    if (!still_ppp())
-	return;
+	if (!still_ppp())
+		return;
 /*
  * Set the receiver parameters
  */
-    if (ioctl(ppp_fd, PPPIOCSMRU, (caddr_t) &mru) < 0) {
-	if ( ! ok_error (errno))
-	    error("ioctl(PPPIOCSMRU): %m(%d)", errno);
-    }
-    if (new_style_driver && ifunit >= 0
-	&& ioctl(ppp_dev_fd, PPPIOCSMRU, (caddr_t) &mru) < 0)
-	error("Couldn't set MRU in generic PPP layer: %m");
-
-    SYSDEBUG ((LOG_DEBUG, "recv_config: asyncmap = %lx\n", asyncmap));
-    if (ioctl(ppp_fd, PPPIOCSRASYNCMAP, (caddr_t) &asyncmap) < 0) {
-	if (!ok_error(errno))
-	    error("ioctl(PPPIOCSRASYNCMAP): %m(%d)", errno);
-    }
+	if (ioctl(ppp_fd, PPPIOCSMRU, (caddr_t) &mru) < 0) {
+		if (errno != EIO && errno != ENOTTY)
+			error("Couldn't set channel receive MRU: %m");
+	}
+	if (new_style_driver && ppp_dev_fd >= 0
+	    && ioctl(ppp_dev_fd, PPPIOCSMRU, (caddr_t) &mru) < 0)
+		error("Couldn't set MRU in generic PPP layer: %m");
+
+	if (ioctl(ppp_fd, PPPIOCSRASYNCMAP, (caddr_t) &asyncmap) < 0) {
+		if (errno != EIO && errno != ENOTTY)
+			error("Couldn't set channel receive asyncmap: %m");
+	}
 }
 
 /********************************************************************
@@ -1146,7 +1284,8 @@
  * is acceptable for use.
  */
 
-int ccp_test (int unit, u_char *opt_ptr, int opt_len, int for_transmit)
+int
+ccp_test(int unit, u_char *opt_ptr, int opt_len, int for_transmit)
 {
     struct ppp_option_data data;
 
@@ -1168,12 +1307,11 @@
 
 void ccp_flags_set (int unit, int isopen, int isup)
 {
-    if (still_ppp()) {
-	int x = get_flags(ppp_dev_fd);
-	x = isopen? x | SC_CCP_OPEN : x &~ SC_CCP_OPEN;
-	x = isup?   x | SC_CCP_UP   : x &~ SC_CCP_UP;
-	set_flags (ppp_dev_fd, x);
-    }
+	int x;
+
+	x = (isopen? SC_CCP_OPEN: 0) | (isup? SC_CCP_UP: 0);
+	if (still_ppp() && ppp_dev_fd >= 0)
+		modify_flags(ppp_dev_fd, SC_CCP_OPEN|SC_CCP_UP, x);
 }
 
 #ifdef PPP_FILTER
@@ -1188,9 +1326,13 @@
 	fp.filter = (struct sock_filter *) pass->bf_insns;
 	if (ioctl(ppp_dev_fd, PPPIOCSPASS, &fp) < 0) {
 		if (errno == ENOTTY)
+		{
 			warn("kernel does not support PPP filtering");
+		}
 		else
+		{
 			error("Couldn't set pass-filter in kernel: %m");
+		}
 		return 0;
 	}
 	fp.len = active->bf_len;
@@ -1213,7 +1355,7 @@
     struct ppp_idle *ip;
 {
     return ioctl(ppp_dev_fd, PPPIOCGIDLE, ip) >= 0;
-} 
+}
 
 /********************************************************************
  *
@@ -1236,6 +1378,8 @@
     }
     stats->bytes_in = req.stats.p.ppp_ibytes;
     stats->bytes_out = req.stats.p.ppp_obytes;
+    stats->pkts_in = req.stats.p.ppp_ipackets;
+    stats->pkts_out = req.stats.p.ppp_opackets;
     return 1;
 }
 
@@ -1248,9 +1392,13 @@
 
 int ccp_fatal_error (int unit)
 {
-    int x = get_flags(ppp_dev_fd);
+	int flags;
 
-    return x & SC_DC_FERROR;
+	if (ioctl(ppp_dev_fd, PPPIOCGFLAGS, &flags) < 0) {
+		error("Couldn't read compression error flags: %m");
+		flags = 0;
+	}
+	return flags & SC_DC_FERROR;
 }
 
 /********************************************************************
@@ -1311,8 +1459,8 @@
 static void close_route_table (void)
 {
     if (route_fd != (FILE *) 0) {
-        fclose (route_fd);
-        route_fd = (FILE *) 0;
+	fclose (route_fd);
+	route_fd = (FILE *) 0;
     }
 }
 
@@ -1331,8 +1479,8 @@
     path = path_to_procfs("/net/route");
     route_fd = fopen (path, "r");
     if (route_fd == NULL) {
-        error("can't open routing table %s: %m", path);
-        return 0;
+	error("can't open routing table %s: %m", path);
+	return 0;
     }
 
     route_dev_col = 0;		/* default to usual columns */
@@ -1380,7 +1528,7 @@
 {
     char *cols[ROUTE_MAX_COLS], *p;
     int col;
-	
+
     memset (rt, '\0', sizeof (struct rtentry));
 
     if (fgets (route_buffer, sizeof (route_buffer), route_fd) == (char *) 0)
@@ -1414,15 +1562,15 @@
     int result = 0;
 
     if (!open_route_table())
-        return 0;
+	return 0;
 
     while (read_route_table(rt) != 0) {
-        if ((rt->rt_flags & RTF_UP) == 0)
+	if ((rt->rt_flags & RTF_UP) == 0)
 	    continue;
 
 	if (kernel_version > KVERSION(2,1,0) && SIN_ADDR(rt->rt_genmask) != 0)
 	    continue;
-        if (SIN_ADDR(rt->rt_dst) == 0L) {
+	if (SIN_ADDR(rt->rt_dst) == 0L) {
 	    result = 1;
 	    break;
 	}
